/*
 * Copyright (C) 1996 Michael R. Elkins <me@cs.hmc.edu>
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */ 

#include "mutt.h"
#include "mutt_curses.h"

#include <string.h>
#include <stdlib.h>

static char CI_searchbuf[STRING] = "";

int ci_search_command (int cur)
{
  int i;
  int j;
  char buf[LONG_STRING] = "";
  int err;
#ifdef HAVE_REGCOMP
  regex_t re;
  char error[STRING];
#elif HAVE_REGCMP
  char *re;
#endif
  
  strfcpy(buf, CI_searchbuf, sizeof(buf));
  /* Get new pattern - pms@romance.kaist.ac.kr */
  if (ci_get_field("Search for: ", buf, sizeof(buf), CI_newsearch) != 0 || !buf[0])
    return(-1);
  strfcpy(CI_searchbuf, buf, sizeof(CI_searchbuf));

  if ((err = REGCOMP(re, CI_searchbuf)) != 0) {
#ifdef HAVE_REGCOMP
    regerror(err, &re, error, sizeof(error));
    mutt_error(error);
#else
    mutt_error("Error in regular expression.");
#endif
    REGFREE(re);
    return(-1);
  }
  
  for (j=0,i=cur + 1; j!=Context->vcount; i++, j++) {
    if (i > Context->vcount - 1) {
      i = 0;
      mutt_error("Search wrapped to top.");
    }
    if (Context->hdrs[*Context->v2r[i]]->env->subject &&
	REGEXEC(re, Context->hdrs[*Context->v2r[i]]->env->subject) == 0) {
      REGFREE(re);
      return(i);
    }

    buf[0] = 0;
    mutt_write_address(buf, sizeof(buf),
		       Context->hdrs[*Context->v2r[i]]->env->from);
    if (REGEXEC(re, buf) == 0) {
      REGFREE(re);
      return(i);
    }
  }
  REGFREE(re);
  mutt_error("Not found.");
  return(-1);
}
