/*
 * Author: kenw@ihs.com (Ken Weinert)
 */

#include "muttlib.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <sys/types.h>
#include <dirent.h>
#include <time.h>

#ifdef ENABLE_RANDOM_SIG

char *
addRandomSig(char *sigFile)
{
  static char newSigFile[LONG_STRING];

  FILE *tmpFP;
  FILE *fixedFP;
  DIR  *sigDir;			/* pointer to directory of signatures */
  char  template[LONG_STRING];
  char  buffer[LONG_STRING];

  struct dirent *dp;		/* pointer to directory entry */
  int   fileCount = 0;		/* count of files in directory */
  int   whichOne;		/* which random file will we use? */
  int   len;

  sprintf(template, "%s/mutt_sig.XXXXXX", Tempdir); 
  strcpy(newSigFile, mktemp(template));
  if ((tmpFP = fopen(newSigFile, "w")) == NULL)
    {
      return NULL;
    }

  if ((sigDir = opendir(sigFile)) == NULL)
    {
      if ((fixedFP = fopen(sigFile, "r")) != NULL)
	{
	  while ((len = fread(buffer, 1, sizeof(buffer), fixedFP)) > 0)
	    {
	      fwrite(buffer, 1, len, tmpFP);
	    }
	  fclose(fixedFP);
	}
      else
	{
	  fprintf(tmpFP, "Could not open directory\n");
	}
    }
  else
    {
      for (dp = readdir(sigDir); dp != NULL; dp = readdir(sigDir))
	{
	  /* don't get ., .., or temp files that start with # or end
	     with ~ */
	  if (dp -> d_name[0] == '.' ||
	      dp -> d_name[0] == '#' ||
	      strchr(dp -> d_name, '~'))
	    {
	      continue;
	    }
	  fileCount++;
	}

      rewinddir(sigDir);
      whichOne = DRAND() * fileCount;

      for (dp = readdir(sigDir); dp != NULL; dp = readdir(sigDir))
	{
	  /* don't get ., .., or temp files that start with # or end
	     with ~ */
	  if (dp -> d_name[0] == '.' ||
	      dp -> d_name[0] == '#' ||
	      strchr(dp -> d_name, '~'))
	    {
	      continue;
	    }
	  if (--whichOne == 0)
	    {
	      strcpy(buffer, "~/.sigfixed");
	      mutt_expand_path(buffer);
	      if ((fixedFP = fopen(buffer, "r")) != NULL)
		{
		  while ((len = fread(buffer, 1, sizeof(buffer), fixedFP)) > 0)
		    {
		      fwrite(buffer, 1, len, tmpFP);
		    }
		  fclose(fixedFP);
		}
	      sprintf(buffer, "%s/%s", sigFile, dp -> d_name);
	      mutt_expand_path(buffer);
	      if ((fixedFP = fopen(buffer, "r")) != NULL)
		{
		  while ((len = fread(buffer, 1, sizeof(buffer), fixedFP)) > 0)
		    {
		      fwrite(buffer, 1, len, tmpFP);
		    }
		  fclose(fixedFP);
		}
	      break;
	    }
	}
      closedir(sigDir);
    }

  fclose(tmpFP);
  return newSigFile;
}

#endif /* ENABLE_RANDOM_SIG */
