#ifndef SORT_H
#define SORT_H

typedef int sort_t (const void *, const void *);

sort_t *mutt_get_sort_func (int);

#ifdef MAIN_C
const char *Sort_methods[] = {
  "date-sent",
  "size",
  "subject",
  "from",
  "mailbox-order",
  "threads",
  "date-received",
  0
};
#else
extern const char *Sort_methods[];
#endif

/* These must be in the same order as in the global var "Sort_methods" */
#define SORTDATE     1   /* the date the mail was sent. */
#define SORTSIZE     2
#define SORTSUBJECT  3
#define SORTFROM     4
#define SORTORDER    5   /* the order the messages appear in the mailbox. */
#define SORTTHREADS  6
#define SORTRECEIVED 7   /* when the message were delivered locally */
#define SORTMAX      7   /* FOO - needs to be changed if more methods */
#define SORTMASK     0x7
#define SORTREVERSE  8

#endif /* SORT_H */
